//-----------------------------------------------------
// Data Scraping   ( based on code by Daniel Shiffman )
//
// It uses a function called "giveMeTextBetween()" which 
// takes 3 arguments: String, first-substring, second-substring
// and then returns the substring between.
// It also uses a function called "printIt()" which takes 3
// arguments: String-to-print, X-location and Y-location
//
// This example gets the temperaature and weather from a webpage.
// ----------------------------------------------------

String url = "https://weather.com/weather/today/l/6f03ddf87585ae5600e3dee28e519d788ddeb749efefa3f236796ef7167fc411";
String onelongstring;
String[] lines;
PFont f; // Global font variable
int x = 20; // Horizontal location
int index = 0;
String temp;
String weather;
int lineCounter = 0;
int bkColor = 255;

void setup() {
  background(255);
  size(700,300);
  f = createFont( "Arial", 24, true);
  textFont(f);
  textAlign(LEFT);
  lines = loadStrings(url);
}

void draw() {
  background(bkColor);
  fill (0);
  // Display headline at x location
  textFont(f,24);
  textAlign (LEFT);
 String[] lines = loadStrings(url);
// println(lines.length);
 onelongstring = join(lines, " ");
 weather = giveMeTextBetween( onelongstring, "class=\"CurrentConditions--tempValue--MHmYY\">", "<span");
 // "weather" should return the current temperature

 bkColor = int(weather);
 bkColor = bkColor + 150;
 printIt("Current Temperature:", 80,90);
 textFont(f,68);
 printIt(weather, 380, 150);
 delay(500);
}

void printIt(String getStr, int getX, int startY) {
   text(getStr,getX, startY );
}

// A function that returns a substring between two substrings
String giveMeTextBetween(String s, String startTag, String endTag) { 
  // Find the index of the beginning tag
  int startIndex = s.indexOf(startTag);
  // If I don't find anything
  if (startIndex == -1) {
    return "";
  }
  // Move to the end of the beginning tag
  startIndex += startTag.length();
  // Find the index of the end tag
  int endIndex = s.indexOf(endTag, startIndex); 
  // If I don't find the end tag,
  if (endIndex == -1) {
    return "";
  }
  // Return the text in between
  return s.substring(startIndex, endIndex);
}
